
// D3DVSD_REG(D3DVSDE_POSITION, D3DVSDT_FLOAT3);   // Position        -- [ 0 ]
// D3DVSD_REG(D3DVSDE_DIFFUSE,  D3DVSDT_D3DCOLOR); // Color           -- [ 5 ]
// D3DVSD_REG(6,                D3DVSDT_FLOAT1);   // Point born-time -- [ 6 ]

// SetVertexShaderConstant(0, matTotal, 4); // Total Matrix
// SetVertexShaderConstant(4, matWorldView, 4); // WorldView Matrix
// SetVertexShaderConstant(8, fConst4, 1); // (Time, FadeFactor, 0, 1)
// SetVertexShaderConstant(9, fConst4, 1); // (BackBufferHeight * PARTICLE_SIZE, PARTICLE_ScaleFactor, 0, 1)

vs.1.1                  // version instruction

// Generate output position
m4x4 oPos, v0, c0       // transform vertices by World/View/Projection matrix

// Generate particle size
m4x4 r1, v0, c4         // Get Camera space position
dp3 r1.w, r1, r1        // r1.w - Square distance to particle (x*x + y*y + z*z)
mul r1.w, r1.w, c9.y    // r1.w = r1.w * DistanceScaleFactor
rsq r1.x, r1.w          // r1.x =  1 / Sqrt(r1.w)
mul oPts.x, r1.x, c9.x  // Emit particle size (scaled to viewport height)

// Generate particle alpha 
sub r0.x, c8.x, v6.x    // How much time is passed ?
mul r0.x, r0.x, c8.y    // Get fade constant (c = time/factor - 1)
add r0.x, r0.x, -c8.w   //   now (r0.x = 0) - maximum particle intensivity
max r0.x, r0.x, -r0.x   // x = abs(x)

add oD0.w, c8.w, -r0.x  // x = (1-x) - Fill alpha with generated value
mov oD0.xyz, v5.xyz

